/* Main js - Tweeg Comming Soon Template */

var last_id = 0,
	menu_show_timeout,
	errors_timeout;
jQuery(document).ready(function() {
	"use strict";
	tweets_call();
	setInterval(function() { tweets_call() }, update_interval);

	/* Countdown */

	if( $('#countdown').length > 0 ) {
		$('#countdown').countdown({
			until: new Date(site_launch_date),
			layout: '<div class="countdown-section"><div class="countdown-amount">{dn}</div><span class="countdown-period">{dl}</span><span class="sep">{sep}</span></div>'
				+'<div class="countdown-section"><div class="countdown-amount">{hnn}</div><span class="countdown-period">{hl}</span><span class="sep">{sep}</span></div>'
				+'<div class="countdown-section"><div class="countdown-amount">{mnn}</div><span class="countdown-period">{ml}</span><span class="sep">{sep}</span></div>'
				+'<div class="countdown-section secs"><div class="countdown-amount">{snn}</div><span class="countdown-period">{sl}</span></div>'
		});
	}

	if( $('#menu_show').length > 0 ) {
		$('#menu_show').click(function() {
			"use strict";
			clearTimeout(menu_show_timeout);
			$(this).toggleClass('active');
			var $feed 	 = $('#tweet-feed'),
				$content = $('#content');

			if( !$feed.hasClass('hidden') ) {
				$feed.addClass('hidden');
				$content.addClass('visible');
				steps_show('#about');

			} else {
				$content.removeClass('visible');
				$feed.removeClass('hidden').addClass('anim');
				menu_show_timeout = setTimeout( function(){ $feed.removeClass('anim'); }, 100 );
			}
			return false;
		});
	}

	if( $('#content-tabs').length > 0 ) {
		$('#content-tabs li a').click(function() {
			"use strict";

			var $th 		 = $(this),
				current_part = $th.attr('href');


			if( !$th.hasClass('current') ) {

				$th.parents('ul').find('li a').removeClass('current');
				$th.addClass('current');	
				$('.part-content').stop( true, true ).fadeOut();
				$(current_part).stop( true, true ).fadeIn();
	
				steps_show(current_part);
			}

			return false;
		});
	}

	/* Forms Submit */

		/* Form Submiting */
	$('#contacts .form-submit').click(function(){
		"use strict";
		var form = $(this).parents('form');
		form.find('.form_item').removeClass('error');
		form.find('.error_block').remove();
		var post_data;
		var errors = formValidation(form),
			output;
		if( Object.keys(errors).length > 0 ) {
			showErrors(form, errors);
		} else {
			$(this).addClass('loading');
			post_data = {
    		    'name'     : $('input[name=name]').val(),
    		    'email'    : $('input[name=email]').val(),
    		    'message'  : $('textarea[name=message]').val()
    		};

			//Ajax post data to server
			jQuery.post('contacts.php', post_data, function(response){	

				$("#contacts_form .form_submit").removeClass('loading');

			    if(response.type == 'error'){ //load json data from server and output message    
			        output = '<div class="error_block">'+response.text+'</div>';
			    } else{
			        output = '<div class="success">'+response.text+'</div>';
			        //reset values in all input fields
			        $("#contacts_form .form_item").val('');
			    }
			    form.find('.field-row').slideUp();
			    form.find(".form_results").hide().html(output).slideDown();
			}, 'json');

		}
		return false;
	});

	$('#content .part-content').each(function(){
		"use strict";
		$(this).mCustomScrollbar({
			autoHideScrollbar: true,
			scrollbarPosition: 'outside'
		});
	});

	if( $('#youtube-bg').length > 0 ) {
		$('#youtube-bg').tubular({
			videoId: youtube_bg_code,
			start: 35  // Starting position in seconds
		});
	}

	if( $('#background-slideshow').length > 0 ) {
		$('#background-slideshow').kenburnsy({
			fullscreen: true
		});
	}

	if( $('body').hasClass('snowflakes') ) {
		snow_init();
	}

	if( $('#gmap').length > 0 ) {
		var opts = {
			lat: 40.7762709, /* Latitude */
			lng: -73.9754292, /* Longtitude */
			disableDefaultUI: true,
			styles: map_styles,
			el: '#gmap'
		};
		if( !$('#gmap').hasClass('streetview') ) {
			new GMaps(opts);
		}
		else {
			new GMaps.createPanorama(opts);
		}

		$('#map-to-top').click(function(){
			$('#primary').fadeToggle();
			return false;
		});

	}

});

$(window).load(function(){
	if( $('#preloader').length > 0 ) {
		setTimeout(function(){
			$('#preloader').fadeOut(400, function() {
				$(this).remove();
			});
		}, 500);
	}
	if( $('#countdown-block').length > 0 ) {
		vertAlign( $('#countdown-block') );
	}
});

/* Twitter grabber */
function tweets_call() {
	"use strict";
	var output;
	jQuery.post('twitter/twitter.php', { 'last_id' : last_id }, function(response){		
		
		output = response;

		var $output = $(output);	
		last_id = $($output[$output.length - 1]).data('id');

		if( !last_id ) {
			last_id = $('#timeline .tweet:last-child').data('id');
		}

		if( output != 'no_tweets' ) {
			jQuery('#timeline ul.slides').html(output);
	
			var tweets_slider = $('#timeline').flexslider({
				controlNav: false,
				animationSpeed: 600,
				slideshowSpeed: 6000,
				directionNav: false,
				start: function(slider) {
					var first_slide   = $(slider.slides[0]),
						current_color = first_slide.data('color'),
						current_type  = first_slide.data('type');

					$('#tweet-feed').addClass('bg_type_'+current_type).fadeIn(300);
					$('#tweet-feed, #tweet-feed .sideskew').css({'background-color': '#'+current_color});

					$(slider).find('li').each(function(){

						var $th = $(this);

						$th.parent().fadeIn();
						$th.css({'marginTop' : -$th.height() / 2});
					});
				},
				before: function(slider) {

					var current = slider.currentSlide + 1 == slider.slides.length ? 0 : slider.currentSlide+1,
						current_color = $(slider.slides[current]).data('color'),						
						current_type  = $(slider.slides[current]).data('type');

					$('#tweet-feed').removeClass('bg_type_light bg_type_dark').addClass('bg_type_'+current_type);
					$('#tweet-feed, #tweet-feed .sideskew').css({'background-color': '#'+current_color});
				}
			});
		}
	}, 'json');
}

/* Vertical Alignment */
function vertAlign(elem) {
	var height = elem.outerHeight();

	elem.css({'marginTop' : -height/2}).fadeIn().addClass('inited');
}

/* Forms Validation */
function formValidation(form) {
	"use strict";
	var error = {};

	if(form) {
		form.find('.form_item').each(function(){
			var $th = $(this);

			if( $th.val() != '' ) {
				if( $th.attr('type') == 'email' ) {
					var emailReg = /^([\w-\.]+@([\w-]+\.)+[\w-]{2,4})?$/;
					if( !emailReg.test( jQuery.trim($th.val()) ) ) {
						error[$th.attr('id')] = 'not_email';
					}
				}
			} else {				
				error[$th.attr('id')] = 'empty';
			}

		});
	}
	return error;
}

/* Validation Errors */
function showErrors(form, errors) {
	"use strict";

	clearTimeout(errors_timeout);
	for(var i in errors) {
		var form_item = form.find($('#'+i)),
			form_item_name = form_item.attr('name').replace('_', ' ');
		form_item.addClass('error');

		if( errors[i] == 'empty' ) {
			form_item.parent().append('<div class="error-msg">This field is requred</div>');
		} else {			
			form_item.parent().append('<div class="error-msg">You entered an invalid email</div>');
		}
	}
	errors_timeout = setTimeout( function(){
		form.find('.error-msg').slideUp(300, function() { $(this).remove(); });
	}, 1400)
}

/* Show steps */
function steps_show(act) {

	if(act) {
		active_part = act;
	}

	$(active_part+ ' .anims').each( function(i, el){
		
		setTimeout(function(){
			$(el).addClass('visible');
		}, 100 + ( i * 100 ));
	
	});
}