<?php

require_once __DIR__ . '/TwitterOAuth/TwitterOAuth.php';
require_once __DIR__ . '/TwitterOAuth/Exception/TwitterException.php';


use TwitterOAuth\TwitterOAuth;

date_default_timezone_set('UTC');

function HexHSL( $HexColor ) {

    $HexColor    = str_replace( '#', '', $HexColor );
    if( strlen( $HexColor ) < 3 ) str_pad( $HexColor, 3 - strlen( $HexColor ), '0' );
    $Add         = strlen( $HexColor ) == 6 ? 2 : 1;
    $AA          = 0;
    $AddOn       = $Add == 1 ? ( $AA = 16 - 1 ) + 1 : 1;
    $Red         = round( ( hexdec( substr( $HexColor, 0, $Add ) ) * $AddOn + $AA ) / 255, 6 );
    $Green       = round( ( hexdec( substr( $HexColor, $Add, $Add ) ) * $AddOn + $AA ) / 255, 6 );
    $Blue        = round( ( hexdec( substr( $HexColor, ( $Add + $Add ) , $Add ) ) * $AddOn + $AA ) / 255, 6 );
    $HSLColor    = array( 'Hue' => 0, 'Saturation' => 0, 'Luminance' => 0 );
    $Minimum     = min( $Red, $Green, $Blue );
    $Maximum     = max( $Red, $Green, $Blue );
    $Chroma      = $Maximum - $Minimum;
    $HSLColor['Luminance'] = ( $Minimum + $Maximum ) / 2;

    if( $Chroma == 0 ) {
        $HSLColor['Luminance'] = round( $HSLColor['Luminance'] * 255, 0 );
        return $HSLColor;
    }
    $Range = $Chroma * 6;
    $HSLColor['Saturation'] = $HSLColor['Luminance'] <= 0.5 ? $Chroma / ( $HSLColor['Luminance'] * 2 ) : $Chroma / ( 2 - ( $HSLColor['Luminance'] * 2 ) );
    if( $Red <= 0.004 || $Green <= 0.004 || $Blue <= 0.004 )
            $HSLColor['Saturation'] = 1;
    if( $Maximum == $Red ) {
        $HSLColor['Hue'] = round( ( $Blue > $Green ? 1 - ( abs( $Green - $Blue ) / $Range ) : ( $Green - $Blue ) / $Range ) * 255, 0 );
    }
    else if( $Maximum == $Green ) {
        $HSLColor['Hue'] = round( ( $Red > $Blue ? abs( 1 - ( 4 / 3 ) + ( abs ( $Blue - $Red ) / $Range ) ) : ( 1 / 3 ) + ( $Blue - $Red ) / $Range ) * 255, 0 );
    }
    else {
            $HSLColor['Hue'] = round( ( $Green < $Red ? 1 - 2 / 3 + abs( $Red - $Green ) / $Range : 2 / 3 + ( $Red - $Green ) / $Range ) * 255, 0 );
    }
    $HSLColor['Saturation'] = round( $HSLColor['Saturation'] * 255, 0 );
    $HSLColor['Luminance']  = round( $HSLColor['Luminance'] * 255, 0 );
    return $HSLColor;
}

/**
 * Array with the OAuth tokens provided by Twitter when you create application
 *
 * output_format - Optional - Values: text|json|array|object - Default: object
 */
$config = array(
    'consumer_key' => 'umDgJqsZYAYt6naKt7g9qjyXX', //Consumer Key (API Key)
    'consumer_secret' => 'zQ7dK8C35KIfPQOkPOZyW6XrchwJ3RMYjiCrr5T1c4Fwd7QSlK', //Consumer Secret (API Secret)
    'oauth_token' => '452682641-2bWKvpbNYjTDmZo0ECfMLLbAW29bFNtLXJWASHBW', //Access Token
    'oauth_token_secret' => 'VnaWoh2vFuTHpAx4L6XkGMhGCAhvsbNAHFGiSQfWI2ouD', //Access Token Secret
    'output_format' => 'object'
);

$search_type = 'statuses/user_timeline'; // Also you can set "statuses/user_timeline" to display tweets by hashtag


/**
 * Instantiate TwitterOAuth class with set tokens
 */
$tw = new TwitterOAuth($config);

/**
 * Returns a collection of the most recent Tweets posted by the user
 * https://dev.twitter.com/docs/api/1.1/get/statuses/user_timeline
 */
$params = array(
    'q' => '#tweegcomingsoon', // Hashtag
    'count' => 10, // Number of tweets
    'exclude_replies' => true
);

/**
 * Send a GET call with set parameters
 */
$response = $tw->get($search_type, $params);

if( $search_type == 'search/tweets' ) {
    $tweets = $response->statuses;
} else {
    $tweets = $response;
}

$last_id = !empty($_POST['last_id']) ? $_POST['last_id'] : 0;

if( $tweets[count($tweets) - 1]->id_str != $last_id) {

    $output = '';
    foreach ($tweets as $tweet) {
        $text    = $tweet->text;
        $user    = $tweet->user;
        $id      = $tweet->id_str;
        $author  = $user->screen_name;
        $userpic = str_replace('_normal', '_bigger', $user->profile_image_url_https);        
        $datetime = new DateTime($tweet->created_at);
        $created = $datetime->format('g:i A - d M Y');
        
        $matches = array();
        $color_code = preg_match('/#[a-f0-9]{6}/', strtolower($text), $matches);
        
        if( !empty($matches[0]) ) {
            $background = str_replace('#', '', $matches[0]);
        } else {            
            $background = $user->profile_background_color;
        }
        $HSLColor = HexHSL($background);
        if( (int)$HSLColor['Luminance'] > 150) {
            $color = 'light';
        } else {
            $color = 'dark';
        }
        
        $output .= '<li class="tweet" data-id="'.$id.'" data-color="'.$background.'" data-type="'.$color.'">';
        $output .= '<div class="twit-header">';
        $output .= '<div class="tweet-userpic"><img src="'.$userpic.'" alt=""></div>';
        $output .= '<div class="tweet-author">@'.$author.'</div>';
        $output .= '<div class="twit-date">'.$created.'</div>';
        $output .= '</div>';
        $output .= '<div class="tweet-text">&#171;'.$text.'&#187;</div>';
        $output .= '</li>';
    }
} else {
    $output = 'no_tweets';
}

    $output = json_encode($output);
    die($output);
?>